package twostackqueue;

import java.util.Stack;

/**
 * A TwoStackQueue is a FIFO dispenser implemented with two stacks.
 */
public class TwoStackQueue<T>
        implements Dispenser<T> {

  // Class invariant:
  // All items that have been added but not removed are in either inputStack or
  // outputStack.
  // All items in outputStack are older than all items in inputStack.
  // The items in inputStack are ordered from oldest (stack bottom) to youngest
  // (stack top).
  // The items in outputStack are ordered from youngest (stack bottom) to oldest
  // (stack top).
  private Stack<T> inputStack;
  private Stack<T> outputStack;

  /**
   * new TwoStackQueue<T>() returns a FIFO dispenser for objects of type T.
   * The implementation uses two stacks.
   */
  public TwoStackQueue() {
    // FIXME.
  }

  /**
   * q.add(t) adds t to q.
   * @param t the item to be added
   */
  public void add(T t) {
    // FIXME.
  }

  /**
   * q.isEmpty() returns true if q is empty.
   * @return
   */
  public boolean isEmpty() {
    // FIXME.
    return true;
  }

  /**
   * q.remove() removes and returns the oldest item in q.
   * @return the oldest item
   */
  public T remove() {
    // FIXME.
    return null;
  }

}
